/*
 * Watching.hpp
 *
 *  Created on: 02.11.2010
 *      Author: stephan
 */

#ifndef WATCHING_HPP_
#define WATCHING_HPP_
#define watching_hpp_version "$Revision: 1.10 $"

#include "VecOfLists.hpp"
//#include "AssignInfos.hpp"
#include <fstream>
#include "Types.hpp"


typedef Ptr32 ClsP;

struct ClsLit{
	static const uint32_t  MAX_LIT = max32>>2;
	uint32_t prop_next		: 1;
	uint32_t next_exists	: 1;
	uint32_t lit 			: 30;
	explicit ClsLit(const Literal& l, const bool not_last):
			prop_next(not_last),next_exists(not_last),lit(l.idx()){asrt(l.idx()<=MAX_LIT);}
	ClsLit(){}
	Literal getLit()const {return Literal(lit);}
	const bool anyNext() const{return next_exists;}
	const bool propNext() const{return prop_next;}
	void setLit(const Literal& l){asrt(l.idx()<=MAX_LIT); lit = l.idx();}
	void setEnd(){prop_next=next_exists=0;}
	void setPropEnd(){prop_next=0;}
};

class Cls{
	uint32_t lbd_low 	: 2;
	uint32_t wtches	: 30;

	ClsLit	 lits[0];

public:
	static inline uint32_t allocSizeFor(const uint32_t lits){return lits-1;}
	uint32_t computeMem(){
		uint32_t idx = 0;
		while(lits[idx++].anyNext());{}
		return idx +1;}

	inline	uint32_t countUnwatched() const;

	uint32_t getLbdLow() const {return lbd_low;}

	Cls(const Literal& a, const Literal& b, const uint32_t& lbd_part):lbd_low(lbd_part),wtches(a.idx() ^ b.idx()){
		asrt(a.idx() <= ClsLit::MAX_LIT); asrt(b.idx() <= ClsLit::MAX_LIT); asrt(lbd_low==lbd_part);}

	Literal	otherWatcher(const Literal& l)const	{asrt(l.idx() <= ClsLit::MAX_LIT); return Literal(wtches ^ l.idx());}
	void	changeWatchers(const Literal& a, ClsLit* neww, const Literal& oldw){
			asrt(a.idx() <= ClsLit::MAX_LIT); asrt(oldw.idx() <= ClsLit::MAX_LIT); asrt(wtches==(a.idx()^oldw.idx()));
			wtches = a.idx() ^ neww->lit; neww->lit = oldw.idx(); }
	void	unsetWatchers(){wtches =0;}
	void	setWatchers(const Literal& a, const Literal& b){
				asrt(a.idx() <= ClsLit::MAX_LIT); asrt(b.idx() <= ClsLit::MAX_LIT);
				wtches = a.idx() ^ b.idx(); }
	ClsLit*	uwBeg(){return lits;}
	void	setPropEnd(const uint32_t& at){asrt(at>=3); lits[at-3].setPropEnd();}
	void	clearLBDPrt(){lbd_low=0;}
	Literal front() const {return lits[0].getLit();}
};

#define FOR_UW_LITS_STRT(cls,l){ClsLit* clit = cls.uwBeg(); do{Literal l(clit->lit)
#define FOR_UW_LITS_END 		}while((clit++)->anyNext());}

#define FOR_ALL_LITS_DO(w,cls,func) { func(w); func(cls.otherWatcher(w));\
		ClsLit* clit = cls.uwBeg(); do{func(Literal(clit->lit));}while((clit++)->anyNext());}



struct WtchEle{
	//static const uint32_t NO_CLS 		= max32 >> 1;
	//static const uint32_t T_DRCT 		= 0; // clp is ternary literal (not valid cls)
	static const uint32_t T_BIN 		= 0; // clp is valid but does not have to be visited in BCP (clause has only two literals that are not assigned at level 0)
	static const uint32_t T_CLS_FIX 	= 1; // clp is valid and cls is fix (not learnt)
	static const uint32_t T_CLS_LRNT 	= 2; // clp is valid and cls is learnt -> part of LBD value is stored as (type - T_CLS_LRNT)

	uint64_t lit	: 30;
	uint64_t type	: 3;
	uint64_t clp	: 31;

	bool isBcpShrt() 	const	{return type == T_BIN;}
	bool isFix()		const	{return type <= T_CLS_FIX;}
	bool isLrnt()		const	{return type >= T_CLS_LRNT;}

	Literal getLit() 	const	{return Literal(lit);}
	ClsP  getClsP()		const	{return ClsP(clp);}

	void setBcpShrt(const Literal& ow){type = T_BIN; lit = ow.idx();}
	void clearBcpShrtIf()		{if(isBcpShrt()){type = T_CLS_FIX;}}
	uint32_t getLBDHigh()const	{asrt(isLrnt()); return type - T_CLS_LRNT;}

	WtchEle(const Literal& a, const ClsP& p):
		lit(a.idx()),type(T_BIN),clp(p.idx()){
		asrt(getLit()==a); asrt(getClsP()==p);}

	WtchEle(const Literal& a, const ClsP& p, const bool is_lrnt, const uint32_t& lbd_high):
		lit(a.idx()),type(T_CLS_FIX + is_lrnt + lbd_high),clp(p.idx()){
		asrt(getLit()==a); asrt(getClsP()==p); asrt(!isFix()==is_lrnt); asrt(isLrnt()==is_lrnt); asrt(!is_lrnt || lbd_high==getLBDHigh());}

	WtchEle(const WtchEle& we, const Literal& nl):
		lit(nl.idx()),type(we.type),clp(we.clp){
		asrt(getLit()==nl);}

	WtchEle(){} //dummy for vectors
	WtchEle(const WtchEle& o):lit(o.lit),type(o.type),clp(o.clp){}

	//bool isDirect()		const	{return type <= T_DRCT;}
	//bool isTmpBin() 	const	{return type == T_TMP_BIN;}
	//Literal getTrnLit()	const	{asrt(isDirect()); return Literal(clp);}

	/*WtchEle(const Literal& a, const Literal& b):
		lit(a.idx()),type(T_DRCT),clp(b.idx()){
		asrt(getLit()==a); asrt(getTrnLit()==b);}*/


};

//inline bool operator==(const WtchEle& a, const WtchEle& b){return a.wtchd==b.wtchd;}


class Watching{
	VecOfLists<WtchEle,Literal>			watches;

public:
	Watching():watches('W'){}
	//inline bool bcpFindNewWatcher(const Literal& false_lit, const Literal& other, const WtchEle& curr_we);
	//inline void clsCreateTern(const Literal& lit0, const Literal& lit1, const Literal& lit2);
	//inline void clsCreateBin(const Literal& lit0, const Literal& lit1);


	inline void clsAddBinPrt(const Literal& to, const Literal& w, const ClsP& ptr);
	inline void clsAddWtched(const Literal& to, const Literal& w, const ClsP& ptr, const bool lrnt, const uint32_t& lbd_high);
	inline uint32_t writeDimacs(std::ofstream& out, bool print_lrnt);

	inline void	changeWatching(const WtchEle& replace, const Literal& other, const Literal& neww);


	WIter<WtchEle> getWtchOfW(const Literal& l)	{return watches.getWIter(l);}
	Iter<WtchEle> getWtchOf(const Literal& l)const	{return watches.getIter(l);}
	Literal 		getLitWithSmallerList(const Variable& v)	{return watches.sizeOf(v.toPosLit()) < watches.sizeOf(v.toNegLit()) ? v.toPosLit() : v.toNegLit();}
	bool isEmpty(const Literal& lit) const		{return watches.sizeOf(lit)==0;}
	void finish(const Literal& lit, WIter<WtchEle> it){watches.finish(lit,it);}
	void clearOf(const Literal& l){watches.clear(l);}
	WtchEle getLastOf(const Literal& l) const {return watches.lastOf(l);}

	void enlarge(const uint32_t& sz){watches.enlarge(sz);}
	void reserveForTotal(const uint32_t& sz){ watches.reserveForTotal(sz);}
	uint32_t litsCount() const {return watches.listCount();}
	uint32_t getTotMem()const{return watches.getMemTotal();}
	void hardClear(){watches.hardClear();}

	inline bool asrtWtchingOK() const;
	inline bool asrtFindWtched(const Literal& lit, const ClsP& cand) const;
	inline bool asrtFindWtched(const Literal& lit, const Literal& cand) const;
};




/*void Watching::clsCreateBinPart(const Literal& a, const Literal& b){
	watches.add(a,WtchEle(b,FALSE_LIT));
}*/

/*
void Watching::clsCreateBin(const Literal& lit0, const Literal& lit1){

	watches.add(lit0,WtchEle(lit1,FALSE_LIT));
	watches.add(lit1,WtchEle(lit0,FALSE_LIT));
}

void Watching::clsCreateTern(const Literal& lit0, const Literal& lit1, const Literal& lit2){

	watches.add(lit0,WtchEle(lit1,lit2));
	watches.add(lit1,WtchEle(lit0,lit2));
	watches.add(lit2,WtchEle(lit0,lit1));
}*/


void	Watching::clsAddWtched(const Literal& to, const Literal& w, const ClsP& ptr, const bool lrnt, const uint32_t& lbd_high){
	watches.add(to,WtchEle(w,ptr,lrnt,lbd_high));
}

void	Watching::changeWatching(const WtchEle& replace, const Literal& other, const Literal& neww){
	watches.add(neww,WtchEle(replace,other));
}

void Watching::clsAddBinPrt(const Literal& to, const Literal& w, const ClsP& ptr){
	watches.add(to,WtchEle(w,ptr));
}

uint32_t Cls::countUnwatched() const{
	uint32_t sz = 0;
	ClsLit* clit = (ClsLit*)&lits;
	do{++sz;}while((clit++)->anyNext());
	return sz;
}


/*
uint32_t Watching::writeDimacs(std::ofstream& out, bool print_lrnt){

	uint32_t clses = 0;
	WtchEle we(INVALID_LIT,true); Literal oth; bool binary;
	for(uint32_t i=0;i!=watches.listCount();++i){
		Literal lit(i);
		Iter<WtchEle> iter = watches.getIter(lit);
		while(iter.getNext(we)){
			binary = we.isBinary();
			if(binary){
				oth = we.getLit();
			}else{
				asrt(iter.hasNext());
				iter.getNext(we);
				Cls& cls 	= glob.getCls(we.getClsP());
				if(!print_lrnt && cls.isLrnt()) continue;
				oth = cls.otherWatcher(lit);
			}

			if(oth < lit) continue;

			out << lit.toDIMACS() << " " << oth.toDIMACS() << " ";
			if(!binary){
				ClsLit* clit = glob.getCls(we.getClsP()).uwBeg();
				do{ out << clit->getLit().toDIMACS() << " ";}while((clit++)->has_next);
			}
			out << "0" << endl;
			++clses;
		}
	}
	return clses;
}
*/




//for each target the Visitor functor is called exactly once
//the second argument is the predecessor by which target was reached first -> hence not all edges are called with visitor
//if visit_start is true the start literal is visited with predecessor "FALSE_LIT"

/*
template<class Visitor, class LitFlag>
void Watching::BFS(const Literal& start, Visitor& visi, LitFlag& flags, const bool visit_start, const bool clear_flags,vector<Literal>& queue){
	asrt(!clear_flags || queue.empty());
	LOG2("BFS run with start " << start.toDIMACS());
	uint32_t qhead = queue.size(); WtchEle we(INVALID_LIT,true);
	if(!visit_start || visi(start,FALSE_LIT).isTrue()){
		flags.setFlag(start); queue.push_back(start);}

	Literal target;
	while(qhead != queue.size()){
		Literal src 		= queue[qhead++]; //asrt(!dag.isLitRepl(src));
		Iter<WtchEle>ii	= getWtchOf(src.flipped());

		while(ii.getNext(we)){
			if(!we.isBinary()){asrt(ii.hasNext());ii.skipNext(); continue;}
			target = we.getLit();

			if(flags.isSet(target)){		 continue;}
			TrBool v_res				= visi(target,src);
			if(v_res.isUnknown()){		qhead=queue.size();break;}
			if(v_res.isTrue()){
				flags.setFlag(target);	queue.push_back(target);}
		}
	}

	LOG2("Finishing BFS run with start " << start.toDIMACS());
	if(clear_flags){clearBFSFlags(flags,queue);}
}
*/

/*
template<class LitFlag>
void Watching::clearBfsFlags(LitFlag& flags, vector<Literal>& queue){
	for(uint32_t i=queue.size();i--;){flags.clearFlag(queue[i]);}
	queue.clear();
}




template<class CollVisi,class MarkVisi, class LitFlag>
void Watching::collectCommon(Literal lits[], uint32_t lsz, CollVisi& coll, MarkVisi& mark, LitFlag& flags, vector<Literal>& common_out){

	if(lsz<2){	if(lsz==1){common_out.push_back(lits[0]);} return;}
	LOG2("Start search for common literals of " << lsz);
	vector<Literal> queue;

	BFS(lits[--lsz],coll,flags,true,true,queue);
	if(coll.common.empty()){LOG2("No common lits ");return;}

	while(lsz--){	asrt(!coll.common.empty());
		BFS(lits[lsz],mark,flags,true,false,queue);
		uint32_t cp = 0;
		for(uint32_t i=0;i!=coll.common.size();++i){
			if(flags.isSet(coll.common[i].first)){
				coll.common[cp++]=coll.common[i];LOG2("Keep lit "<<coll.common[i].first.toDIMACS());}
		}
		clearBFSFlags(flags,queue);
		if(cp == 0){LOG2("No common lits ");return;}
		coll.common.resize(cp);
	}
	asrt(!coll.common.empty());
	LOG2("By now common lits: " << coll.common.size());

	//take only topmost common literals -> others are redundant
	for(uint32_t i=coll.common.size();i--;){flags.setFlag(coll.common[i].first);LOG2("Flag lit"<<coll.common[i].first.toDIMACS());}
	for(uint32_t i=coll.common.size();i--;){
		if(!flags.isSet(coll.common[i].second)){common_out.push_back(coll.common[i].first);}
		else{LOG2("Dont take common " << coll.common[i].first.toDIMACS() << " because predecessor is taken: " << coll.common[i].second.toDIMACS());}
		flags.clearFlag(coll.common[i].first);
	}

	LOG2("Found common literals: " << common_out.size());
	asrt(!common_out.empty());
}


bool Watching::asrtFindWtched(const Literal& lit, const ClsP& cand) const{
	Iter<WtchEle> it = watches.getIter(lit);
	WtchEle we(FALSE_LIT,FALSE_LIT);
	while(it.getNext(we)){
		if(we.isShort()){continue;}
		if(we.getClsP()==cand) return true;
	}
	return false;
}


bool Watching::asrtFindWtched(const Literal& lit, const Literal& cand) const{
	Iter<WtchEle> it = watches.getIter(lit);
	WtchEle we(FALSE_LIT,FALSE_LIT);
	while(it.getNext(we)){
		if(!we.isShort()){ continue;}
		if(!vals.litKnwn(we.getSecLit())){
			LOG0("Binary " << lit.toDIMACS() << " and " << cand.toDIMACS() << " have unknown third lit");
			return false;}
		if(we.getFrstLit()==cand) return true;
	}
	return false;
}

bool Watching::asrtWtchingOK() const{
	bool ok = true; WtchEle we(FALSE_LIT,FALSE_LIT);
	Literal ol; ClsP oc;

	for(uint32_t i=watches.listCount();i--;){
		Literal lit(i);
		Iter<WtchEle> it = watches.getIter(lit);
		while(it.getNext(we)){
			if(we.isShort()){
				ol = we.getFrstLit();
				if(!asrtFindWtched(ol,lit)){ ok = false;
					LOG0("Binary " << lit.toDIMACS() << " and " << ol.toDIMACS() << " only one direction");}
			}else{
				if(!it.getNext(we)){LOG0("Bad watching number in lit " << lit.toDIMACS()); return false;}
				ClsP clp = we.getClsP();
				Cls& cls = glob.getCls(clp);
				ol		 = cls.otherWatcher(lit);
				if(!asrtFindWtched(ol,clp)){ok = false;
					LOG0("Clause " << clp.idx() << " only linked by " << lit.toDIMACS() << " but not by " << ol.toDIMACS());}
			}
		}
	}
	LOG1("Watching::asrtWtchingOK is " << (ok?"ok":"bad"));
	return ok;
}
*/

#endif /* WATCHING_HPP_ */
